#include "defs.inc"
  ORG START_ADDR
; 0xCB7F  => BC=crc

;CALL FS_FNDF ; DE - name of file for finding, out HL - string FAT record of file
;CALL F_OPEN ; DE - name of file for opening, out C==1 if file not founded
;CALL F_READ ; HL - addr for store readed data, BC - size of readed data

#ifdef RK86
#ifdef SD_ROM
#else
  jmp 0f800H
  nop
#endif
#endif

ENTRY:
;  LXI SP,03f00H
#ifdef MX2
  call 0c84eH  ;   
#endif
  lxi h,BUF
  lxi b,2048-256
clrmem:
  mvi m,0
  inx h
  dcx b
  mov a,c
  ora b
  jnz clrmem
  CALL FS_RST
LOOP: 
  MVI C,38H
  LXI H,LINEBUF
LOOP0:
  mvi m,0
  inx h
  DCR C
  JNZ LOOP0
  LXI H,A_DRIVE
  CALL PRINT
  LXI H,CWD
  CALL PRINT
  MVI C,'>'
  CALL PUTC
  CALL READLN
  LXI H,LOOP
  PUSH H
  LXI H,CMDLST
LOOP1:  MOV A,M
  ORA A
  JZ RUNFILE
  LXI D,LINEBUF
LOOP2:  MOV A,M
  ORA A
  JZ LOOP3
  LDAX D
  CMP M
  JNZ LOOP4
  INX D
  INX H
  JMP LOOP2
LOOP3:  LDAX D
  ORA A
  JZ LOOP5
  CPI 20H
  JZ LOOP5
LOOP4:  MOV A,M
  INX H
  ORA A
  JNZ LOOP4
  INX H
  INX H
  JMP LOOP1
LOOP5:  INX H
  MOV E,M
  INX H
  MOV D,M
#ifdef GAL
  call 02edH
#else
  LXI H,NEWLINE
  CALL PRINT
#endif
  XCHG
  PCHL

PRINTN: MOV C,M
  INX H
  CALL PUTC
  DCR B
  JNZ PRINTN
  RET

C_DIR:
  LXI D,LINEBUF+2
  INX D
  LDAX D
  CPI 20H
  JZ $-4
  ORA A
  JNZ $+6
  LXI D,ALLFILS
  CALL FS_FNDF
  JC C_DIRNO
C_DIR1: PUSH H
  CALL IfKeyPress ;    
  CPI 0FFH    ;         
  JNZ $-5
  LXI B,11
  DAD B
  MOV A,M
  POP H
  ANI 8
  JNZ C_DIR2
  MVI B,8
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  MVI B,3
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  mov A,M
  ani 010H
  jz C_DIR11
  LXI H,NODIR+4 ;_DIR
  CALL PRINT
  jmp C_DIR12
C_DIR11:
  mov A,L
  adi 012H
  mov L,A
  mov A,M
  call PRHEX
  dcx H
  mov A,M
  call PRHEX
C_DIR12:
  LXI H,NEWLINE
  CALL PRINT
C_DIR2: CALL FS_FNDN
  JNC C_DIR1
  RET
C_DIRNO:LXI H,NOFILES
  JMP PRINT

C_CD: LXI H,LINEBUF+1
  INX H
  MOV A,M
  CPI 20H
  JZ $-4
  ORA A
  JNZ C_CD1
  LXI H,NEWLINE
  CALL PRINT
  LXI H,CWD
  JMP PRINT
C_CD1:  XCHG
  CALL FS_CHDIR
  RNC
  LXI H,NODIR
  JMP PRINT

C_X: 
  CALL SD_OFF
#ifdef MX2
  JMP 0F800H
#endif
#ifdef STD
  JMP 0C800H
#endif
#ifdef RK86
  JMP 0F800H
#endif
#ifdef GAL
  pop D ;garbage read
  ret   ;return to start promt
#endif

#ifdef MX2
C_LRD:
  LXI D,LINEBUF+2
  CALL FS_FNDF
  JC C_DIRNO ; no file
   ;  HL  FAT   
  LXI D,LINEBUF+25H
  mvi c,7
C_LRD_LOOP1:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_LRD_LOOP1
  mvi A,20H
  STAX D
  INX D
  mvi c,2
C_LRD_LOOP2:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_LRD_LOOP2
  LXI D,LINEBUF+2
  CALL F_OPEN
  LXI B,5 ;   RKX      ,  ( )
  LXI H,LINEBUF+20H
  CALL F_READ
  LXI H,LINEBUF+20H
  MOV e,M
  INX H
  MOV d,M
  INX H
  MOV A,M
  INX H
  MOV b,M
  SUB E
  MOV c,A
  MOV A,b
  SBB D
  MOV b,A
  INX B
  PUSH D ;  
  PUSH B ;  ,  
  LXI H,LINEBUF+24H
  MOV A,M
  CPI 0E6H ;     ,   
  JZ NOFNAME
  LXI B,12 ;   RKX   
  LXI H,LINEBUF+25H
  CALL F_READ
RD_E6_LOOP:
  LXI H,LINEBUF+31H
  LXI B,1
  CALL F_READ
  CPI 0E6H ;     
  JNZ RD_E6_LOOP
NOFNAME:
  LXI H,LINEBUF+25H ;    
  call 0F848H ;       RAM Disk
  pop B ;  ,  
  push B
  LXI H,0 ;   
  CALL F_READ ; reading
  LXI H,0 ;   
  pop D ;    
  call 0F83FH ;    RAM Disk
  pop H ;  HL  
  call 0F842H ;   
  LXI H,RWR_OK
  JMP PRINT

C_SRD: 
  LXI D,LINEBUF+2
  CALL FS_FNDF
  JC C_DIRNO ; no file
  push H ;  HL  FAT   
  CALL F_OPEN 
  LXI H,LINEBUF+2
C_SRR1: 
  MOV A,M
  INX H
  CPI 0
  JZ C_SRR2 ;  SD  RAM  
  CPI 2CH
  JNZ C_SRR1
  pop B     ;      ,   SD  RAM  
  LXI D,LINEBUF+20H
  mvi c,7  ;      RAM      RAMFOS
C_SRD_LOOP3:
  MOV A,M
  CPI 2EH
  JNZ C_SRD_LOOP4
  MVI A,20H
  DCX H
C_SRD_LOOP4:
  STAX D
  INX D
  INX H
  DCR C
  JP C_SRD_LOOP3
  mvi A,20H
  STAX D
  INX D
  INX H
  mvi c,2
C_SRD_LOOP5:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_SRD_LOOP5
  JMP C_SRD_LOOP2
C_SRR2: 
  pop H ;  HL  FAT   
  LXI D,LINEBUF+20H
  mvi c,7 ;      SD     RAMFOS
C_SRD_LOOP1:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_SRD_LOOP1
  mvi A,20H
  STAX D
  INX D
  mvi c,2 ;  
C_SRD_LOOP11:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_SRD_LOOP11
C_SRD_LOOP2:
  LXI H,0H
C_RD_E6_LOOP: ;  RKX 
  LXI B,1
  CALL F_READ
  CPI 0E6H ;     
  JNZ C_RD_E6_LOOP
  PUSH H      ;   RKX 
  LXI H,LINEBUF+20H ;    
  call 0F848H ;       RAM Disk
  call 0F84BH ;      'call 0F848H'
  pop H ;     
  JNZ C_DIRNO ; no file
  call 0F84EH ;      HL
  push D ;     
  LXI D,LINEBUF+2 ;     
  CALL FS_FNDF
  CALL F_OPEN 
  LXI H,0
  pop B ;   ( )
  CALL F_WRITE
  LXI H,RWR_OK
  JMP PRINT
#endif

C_RWR: 
  LXI D,LINEBUF+2
  CALL F_OPEN
  JC C_DIRNO ; no file
  LXI H,LINEBUF+2
C_RWR1: 
  INX H
  MOV A,M
  CPI 0
  JZ C_RWR2
  CPI 2CH
  JNZ C_RWR1
C_RWR2: 
  CALL R65
  LXI H,ERR
  JC PRINT
  LHLD LINEBUF+26  ;size 
  MOV  C,L  ;
  MOV  B,H  ;
  LHLD LINEBUF+24  ;   
  LXI D,LINEBUF
  LDAX D
  CPI 'R'
  JZ C_RWR3
  CALL F_WRITE
  JMP C_RWR4
C_RWR3: 
  CALL F_READ
C_RWR4: 
  LXI H,RWR_OK
  JMP PRINT

;**********************************************
RUNFILE: LXI H,NEWLINE
  CALL PRINT
  LXI H,LINEBUF
  MVI C,'.'
  CALL STRCHR
  JNC RUNF1
  LXI D,DOTRK
  CALL STRCPY
RUNF1:  LXI D,LINEBUF
  CALL F_OPEN
#ifdef MX2
  JNC RD_4B
  LXI H,LINEBUF
  MVI C,'.'
  CALL STRCHR
  LXI D,DOTRKS
  CALL STRCPY
  LXI D,LINEBUF
  CALL F_OPEN ;  RKS 
  JC C_DIRNO ; no file
  LXI H,LINEBUF+24
  MVI M,'S'
#else
  JC C_DIRNO ; no file
#endif
RD_4B:
#ifdef GAL
RD_G0:
  LXI B,6 ;   GTP  Block ID, block size and sync byte 0xa5
  LXI H,LINEBUF
  CALL F_READ
RD_G2:
  LXI H,LINEBUF
  MOV A,M
  CPI 010h
  JNZ RD_G1
RD_G3:
  LXI H,LINEBUF
  LXI B,1
  CALL F_READ
  CPI 0A5h
  JNZ RD_G3
RD_G1:
#endif
  LXI B,4 ;   RK?    /           
  LXI H,LINEBUF
  CALL F_READ
  LXI H,LINEBUF
;#ifdef RK86    ;?
;  MOV A,M
;  CPI 0E6H
;  JNZ RUNF2
;  LXI B,1
;  LXI H,LINEBUF+4
;  CALL F_READ
;  LXI H,LINEBUF+1
;RUNF2:
;#endif
#ifdef RK86
  MOV D,M
  INX H
  MOV E,M
  INX H
  MOV B,M
  INX H
  MOV A,M
  SUB E
  MOV C,A
  MOV A,B
  SBB D
  MOV B,A
  INX B  ; 
  XCHG
  PUSH H ;  ,  ret  F_READ     
  push B
  push B
  mov A,H
  call PRHEX
  mov A,L
  call PRHEX
  MVI C,','
  CALL PUTC
  mov A,B
  call PRHEX
  POP B
  mov A,C
  call PRHEX
  POP B
#else
  MOV e,M
  INX H
  MOV d,M
  INX H
  MOV A,M
  INX H
  MOV b,M
  SUB E
  MOV c,A
  MOV A,b
  SBB D
  MOV b,A
  XCHG
  PUSH H ;  ,  ret  F_READ     
  mov A,H
  call PRHEX
  mov A,L
  call PRHEX
  push B
  MVI C,','
  CALL PUTC
  pop B
  mov A,B
  call PRHEX
  mov A,C
  call PRHEX
#endif

#ifdef MX2
  push H
  LXI H,LINEBUF+24
  MOV A,M
  CPI 'S'
  JNZ RD_RKX ; RKX,     0xE6  
  pop H
  CALL F_READ
  LXI D,M2MON
  CALL F_OPEN ;   
  JNC RUNF3
  pop H
  JMP C_DIRNO ; no file
RUNF3:
  LXI H,0C000H
  LXI B,4096
  CALL F_READ
  JMP 0C000H
RD_RKX:
  push B
RUNF4:
  LXI H,LINEBUF+26
  LXI B,1
  CALL F_READ
  CPI 0E6H ;     
  JZ  RUNF6
RUNF5:
  LXI B,1
  INX H
  CALL F_READ
  CPI 0E6H ;
  JNZ RUNF5
RUNF6:
  pop B
  pop H
#endif
  CALL F_READ
#ifdef GAL
  pop B ;not needed
  pop B ;not needed
#endif
  RET

READLN: LXI H,LINEBUF
READL1: CALL GETC
  CPI 8
  JZ READL3
  CPI 5FH
  JZ READL3
  CPI 18H
  JZ READL4
  MVI M,0
  CPI 0DH
  RZ
#ifdef GAL
  CPI 1DH       
  JNZ READL5    
  DCX H         
  JMP READL2    
READL5:
#endif
  MOV M,A
  INX H
READL2: MOV C,A
  CALL PUTC
  JMP READL1
READL3: MOV A,L
  CPI LINEBUF & 255
  JZ READL1
  MVI C,8
  CALL PUTC
  MVI C,20H
  CALL PUTC
  MVI C,8
  CALL PUTC
  DCX H
  JMP READL1
READL4: MOV A,M
  ORA A
  JZ READL1
  CPI 0DH
  JZ READL1
  INX H
  JMP READL2
;**********************************************
SET_LAST_SPACE:
  INX D
  push D
  mvi c,0AH
R66:
  LDAX D
  CPI 0
  JNZ R68
  MVI A,20H
  STAX D
  JMP R67
R68:
  INX D
  DCR C
  JNZ R66
R67:
  pop D
  ret
;**********************************************
;    
;**********************************************
R65:
  XCHG
#ifdef MX2
  call SET_LAST_SPACE
  call 0c839H ;     DE  ,   HL
  shld LINEBUF+24
  RC
  call 0c839H ;     DE  ,   HL
  shld LINEBUF+26
  RC
  ret
#else
  LXI  H,0
  shld LINEBUF+24
  shld LINEBUF+26
  CALL R7C 
  shld LINEBUF+24
  RC
  CALL R7C 
  shld LINEBUF+26
  RC
  ret
;*********************************************
;   16 
;*********************************************
R7C:  
      LXI  H,0 
      MVI  B,0
R7F:  
      LDAX D
      INX  D
      CPI  00H
      JZ   R7E 
      CPI  2CH
      RZ
      CPI  20H
      JZ   R7F 
      SUI  30H
      JM   R79 
      CPI  0AH
      JM   R80 
      CPI  11H
      JM   R79 
      CPI  17H
      JP   R79 
      SUI  07H
R80:
      MOV  C,A
      DAD  H
      DAD  H
      DAD  H
      DAD  H
      JC   R79 
      DAD  B
      JMP  R7F 
R79:
  STC
R7E:
      RET
#endif

;*********************************************
NEWLINE:DB 0DH,0AH,0

#ifdef GAL
A_DRIVE:DB "A:",0
NOFILES:DB "NO FILE(S)",0DH,0

#else
A_DRIVE:DB 0DH,0AH,"A:",0
NOFILES:DB "NO FILE(S)",0

#endif

RWR_OK: DB "OK",0
ERR:    DB "ERR",0
ALLFILS:DB "*",0
NODIR:  DB 0DH,0AH,"NO DIR",0

#ifdef STD
DOTRK:  DB ".RKS",0
#endif

#ifdef MX2
DOTRK:  DB ".RKX",0
DOTRKS: DB ".RKS",0
M2MON:  DB "M2_C000.MON",0

#endif

#ifdef RK86
DOTRK:  DB ".RKR",0
#endif

#ifdef GAL
DOTRK:  DB ".GTP",0
#endif

CMDLST: DB "DIR",0
        DW C_DIR
        DB "CD",0
        DW C_CD
        DB "X",0
        DW C_X
        DB "R",0
        DW C_RWR
        DB "W",0
        DW C_RWR
#ifdef MX2
        DB "L",0
        DW C_LRD
        DB "S",0
        DW C_SRD
#endif
        DB 0

#include "sd_proc.inc"
#include "fs_proc.inc"

#ifdef GAL
;g_putchr_rst_f: equ 0x0020    ; prints a character in A to the screen 
;at current cursor location.
PUTC:
 mov A,C
 call gPUTC
 ret

;g_printstr_f: equ 0x0937    ; prints a string pointed by DE
PRINT:
 push D
 push H
 XCHG
 call gPRINT
 pop H
 pop D
 ret

;g_print_word_f: equ 0x08ed    ; prints a 16-bit number pointed
;by DE to the screen at the current cursor location.
PRHEX:
 push PSW
 RAR
 RAR
 RAR
 RAR
 ani 0FH
 sui 0AH
 jm  prh1
 adi 07H
prh1:
 adi 3AH
 call gPUTC
 pop  PSW
 ani 0FH
 sui 0AH
 jm  prh2
 adi 07H
prh2:
 adi 3AH
 call gPUTC
 ret

GETC:
;exx   
;ld (hl),'_' ;Print cursor at location (HL')
 DB 0D9H ; ;exx  Z80 opcodes... :)
 mvi m,05FH
 DB 0D9H ; ;exx  Z80 opcodes... :)
 call gGETC
 ret

IfKeyPress:
 push H
 lxi H,02000h+31 ; test if SPACE is pressed
 mov A,M
 push PSW
 pop PSW
 pop H
 ret
#endif
#ifdef RK86
ORG 0f7ffh
#else
ORG 0ffffh
#endif
    nop
  END
